//
//  ViewController.swift
//  closure_map
//
//  Created by yoshiyuki oshige on 2016/08/01.
//  Copyright © 2016年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        
        let numbers = [4,7,2,9]
        //配列のすべての値を2倍にする
        let array1 = numbers.map({(v:Int) -> Int in
            return v*2
        })
        print(array1)
        
        //引数のクロージャを外に出した書式
        let array2 = numbers.map{(v:Int) -> Int in
            return v*2
        }
        print(array2)
        
        //型推論を利用し、returnを省略した書式
        let array3 = numbers.map{v in v*2}
        print(array3)
        
        //引数を省略した書式
        let array4 = numbers.map{$0*2}
        print(array4)
        
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

