//
//  ViewController.swift
//  class_propertyObserver
//
//  Created by yoshiyuki oshige on 2016/08/17.
//  Copyright © 2016年 yoshiyuki oshige. All rights reserved.
//

import UIKit


class Player {
    var times = 0
    var level:Int {
        
        willSet {
            print("----------")
            print("willSet \(newValue)")
        }
        
        didSet {
            if oldValue != level {
                times += 1
                print("\(times)回目の更新")
                print("\(oldValue) → \(level)")
            } else {
                print("値は変化なし")
            }
        }
    }
    
    //イニシャライザ
    init (){
        level = 0
    }
}

class ViewController: UIViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Playerクラスのインスタンスを作って試す
        let thePlayer = Player()
        thePlayer.level = 10
        thePlayer.level = 10 // 値が変化しないのでカウントしない
        thePlayer.level = 15
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
}


