//
//  ViewController.swift
//  struct_protocol
//
//  Created by yoshiyuki oshige on 2016/08/23.
//  Copyright © 2016年 yoshiyuki oshige. All rights reserved.
//

import UIKit

// Monsterプロトコル
protocol Monster {
    var monsterName:String {get}
    var hp:Int {get set}
    mutating func updateHP(pt:Int)
}

class ViewController: UIViewController {
    
    // Monsterプロトコルを採用しているBokemon構造体
    struct Bokemon: Monster {
        // プロパティ（プロトコル準拠）
        private(set) var monsterName:String // アクセス権がリードオンリー
        var hp:Int
        // hpを変更するメソッド
        mutating func updateHP(pt:Int) {
            hp += pt
        }
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        // モンスターを作る
        var aMonster = Bokemon(monsterName: "スイフィー", hp: 200)
        print(aMonster.monsterName)
        print("HPポイント \(aMonster.hp)")
        // HPに30ポイント加算する
        aMonster.updateHP(pt: 30)
        print("HPポイント \(aMonster.hp)")
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

