//
//  ViewController.swift
//  struct_subscript
//
//  Created by yoshiyuki oshige on 2016/08/23.
//  Copyright © 2016年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    struct Stock {
        var name:String
        var data:[String:Int] = [:]
        
        // イニシャライザ
        init(name:String){
            self.name = name
        }
        
        // サブスクリプト
        subscript(color:String, size:Double) -> Int {
            // 値の取り出し
            get {
                let key = color + String(size)
                if let value = data[key] {
                    return value
                } else {
                    return 0
                }
            }
            
            // 値の設定
            set {
                let key = color + String(size)
                data[key] = newValue // 新しい値を設定する
            }
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // タイガーシューズの在庫を作る
        var shoes = Stock(name: "Tiger")
        shoes["green", 24.5] = 3
        shoes["green", 25.0] = 5
        
        // 在庫を更新する
        shoes["green", 24.5] -= 2
        shoes["green", 25.0] += 1
        shoes["red", 26.0] = 5
        
        // 在庫を確認する
        print(shoes.name)
        print(shoes["green", 24.5])
        print(shoes["green", 25.0])
        print(shoes["red", 26.0])
        // 在庫データがないもの
        print(shoes["red", 25.5])
        print(shoes["white", 25.0])
        
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
}

